program demo;

uses
  windows, messages,
  sys_include,
  u_ZGL,
  u_MathTypes;

type
  TVerticle = record  //,      
    Vertex: TVector3D;//  
    Tex1  : TVector2D;//  1
    Tex2  : TVector2D;//  2
  end;

var
  Qube: array[0..7] of TVerticle;//    
  Indexes: array[0..35] of WORD; // .    ,    
                                 //   Qube  

  V_Buf, I_Buf: TGLBuffer;//     
  T_Main,
  T_Sec: TGLTexture;      // 

  angle: single;          // . . 

procedure glUpdate;//  
begin
  angle := angle + 0.15;//  
end;

procedure glRender;//  
begin
  ogl.Clear(true,true);                      //     
  ogl.AntiAliasing(true);                    // AntiAliasing'.    params.ini AntiAliasing
                                             //,     
  ogl.Set3D(0.1,10.0,90,1.3333);             // 3D 

  ogl.Translate(0,0,-3);                     //   Z  -3
  ogl.Rotate(angle,1,-1,2);                  //    angle.   X: 1*angle; Y: -1*angle; Z: 2*angle;

  tex.EnableTextures2D;                      // 
  tex.AssignToTexUnit(T_Main,0,ENV_REPLACE); //  T_Main     (0).   Replace, ..    
  tex.AssignToTexUnit(T_Sec,1,ENV_MODULATE); //  T_     (1).   Modulate, ..     
  tex.EnableSphereTexCoords;                 //    .      ,    T_Sec

  vbo.Enable(V_Buf,I_Buf);                   // ,     .
                                             //,  -     ,
                                             // ,   -     ( IOpenAL)
  vbo.EnableArray(ARR_VERTEX);               //     
  vbo.EnableArray(ARR_TEXCOORD);             //     1  
  vbo.EnableArray(ARR_TEXCOORD);             //     2  
  vbo.VertexPointer(28,0,3);                 //     .
                                             //stride =       ,    SizeOf(TVerticle) = 28
                                             //start_pos =             
                                             //elements_count =      
  vbo.TexCoordPointer(28,12,2,0);            //      .
  vbo.TexCoordPointer(28,20,2,1);            //  , tex_index   . (. tex.AssignToTexUnit)

  vbo.RenderBuffer(TRIANGLES,36,0);          //   
                                             //Primitiv_Type =     
                                             //Indexes_count =    .   36, ,   36/3(  ) = 12 
                                             //offset =    
  vbo.DisableArray(ARR_VERTEX);              //
  vbo.DisableArray(ARR_TEXCOORD);            //     
  vbo.DisableArray(ARR_TEXCOORD);            //
  vbo.Disable;

  tex.DisableSphereTexCoords;                //   
  ogl.AntiAliasing(false);                   // AntiAliasing
  ogl.Swap;                                  //    ,    
end;

procedure glInit;//  
begin
  fsys.AddPacksDir('Data');//     "Data\", ..    
  // 
  Qube[0].Vertex := math3D.NewVector3D(-1,-1,-1);
  Qube[1].Vertex := math3D.NewVector3D(-1, 1,-1);
  Qube[2].Vertex := math3D.NewVector3D( 1, 1,-1);
  Qube[3].Vertex := math3D.NewVector3D( 1,-1,-1);
  Qube[4].Vertex := math3D.NewVector3D(-1,-1, 1);
  Qube[5].Vertex := math3D.NewVector3D(-1, 1, 1);
  Qube[6].Vertex := math3D.NewVector3D( 1, 1, 1);
  Qube[7].Vertex := math3D.NewVector3D( 1,-1, 1);

  Qube[0].Tex1 := math3D.NewVector2D(0,0);
  Qube[1].Tex1 := math3D.NewVector2D(1,0);
  Qube[2].Tex1 := math3D.NewVector2D(1,1);
  Qube[3].Tex1 := math3D.NewVector2D(0,1);
  Qube[4].Tex1 := math3D.NewVector2D(1,1);
  Qube[5].Tex1 := math3D.NewVector2D(0,1);
  Qube[6].Tex1 := math3D.NewVector2D(0,0);
  Qube[7].Tex1 := math3D.NewVector2D(1,0);

  Qube[0].Tex2 := math3D.NewVector2D(0,0);
  Qube[1].Tex2 := math3D.NewVector2D(1,0);
  Qube[2].Tex2 := math3D.NewVector2D(1,1);
  Qube[3].Tex2 := math3D.NewVector2D(0,1);
  Qube[4].Tex2 := math3D.NewVector2D(1,1);
  Qube[5].Tex2 := math3D.NewVector2D(0,1);
  Qube[6].Tex2 := math3D.NewVector2D(0,0);
  Qube[7].Tex2 := math3D.NewVector2D(1,0);

  Indexes[00] := 0;
  Indexes[01] := 1;
  Indexes[02] := 2;

  Indexes[03] := 0;
  Indexes[04] := 2;
  Indexes[05] := 3;

  Indexes[06] := 3;
  Indexes[07] := 2;
  Indexes[08] := 6;

  Indexes[09] := 3;
  Indexes[10] := 6;
  Indexes[11] := 7;

  Indexes[12] := 7;
  Indexes[13] := 6;
  Indexes[14] := 5;

  Indexes[15] := 7;
  Indexes[16] := 5;
  Indexes[17] := 4;

  Indexes[18] := 4;
  Indexes[19] := 5;
  Indexes[20] := 1;

  Indexes[21] := 4;
  Indexes[22] := 1;
  Indexes[23] := 0;

  Indexes[24] := 1;
  Indexes[25] := 5;
  Indexes[26] := 6;

  Indexes[27] := 1;
  Indexes[28] := 6;
  Indexes[29] := 2;

  Indexes[30] := 7;
  Indexes[31] := 3;
  Indexes[32] := 0;

  Indexes[33] := 7;
  Indexes[34] := 0;
  Indexes[35] := 4;

  // 
  V_Buf := vbo.NewID(224,BUF_DATA,@Qube[0],'V_Buf');     //224 = (3*4+2*4+2*4)*8
  I_Buf := vbo.NewID(72,BUF_ELEMENT,@Indexes[0],'I_Buf');//72  = 36*2

  // 
  //jpg  ,      ,  ,      "Textures special pack"
  T_Main := tex.LoadTexture('Data\B017.jpg',true,true);
  T_Sec  := tex.LoadTexture('Data\B150.jpg',true,true);

  tex.FilterGroup(TF_ANISOTROPY);//  
end;

procedure glMessages(msg: cardinal; w: WPARAM; l: LPARAM);//    . 
begin
  case msg of
    WM_KEYUP:
    begin
      case w of
        VK_ESCAPE: eng.Quit;
        VK_TAB   : tex.ScreenShot('screen.bmp');
      end;
    end;
  end;
end;

procedure glFree;//  .
begin
  //        
end;

var
  WinDir: array[0..127] of char;

begin
  InitENZGLINE;//   
  eng.SetProc(PROC_INIT,@glInit);    // ,   
  eng.SetProc(PROC_FREE,@glFree);    // ,   
  eng.SetProc(PROC_UPDATE,@glUpdate);// ,   
  eng.SetProc(PROC_RENDER,@glRender);// ,  
  eng.SetProc(PROC_MSG,@glMessages); // ,     

  // 2        Windows
  GetWindowsDirectory(WinDir,127);
  oal.PlayMusic(PAnsiChar(WinDir+'\system32\oobe\images\title.wma'),true);

  // 
  inp.CursorHide;

  // . UPS=100 ,     100   
  eng.Loop(100);
end.
