unit u_MathTypes;

interface

type
  TVector2D = record
  case integer of
    0: (x, y: single);
    1: (u, v: single);
    2: (s, t: single);
    3: (vec: array[0..1] of single);
  end;

  TVector3D = record
  case integer of
    0: (x, y, z: single);
    1: (u, v, f: single);
    2: (vec: array[0..2] of single);
  end;

  TPlane = record
  case integer of
    0: (x, y, z, dst: single);
    1: (normal: TVector3D; distance: single);
    2: (plane: array[0..3] of single);
  end;

  TMatrix4x4 = record
  case integer of
    0: (_11, _12, _13, _14,
        _21, _22, _23, _24,
        _31, _32, _33, _34,
        _41, _42, _43, _44: single);
    1: (m: array[0..3,0..3] of single);
  end;

  TQuaternion = record
  case integer of
    0: (x, y, z, w: single);
    1: (q: array[0..3] of single);
  end;

  TQuad = record
  case integer of
    0: (min, max: TVector2D);
    1: (x1, y1, x2, y2: single);
  end;

  TBox = record
  case integer of
    0: (min, max: TVector3D);
    1: (x1, y1, z1, x2, y2, z2: single);
  end;

implementation

end.
