unit u_ZGL;

interface

uses
  sys_include;

function enZGLineInit: IEngine; external 'enZGLine.dll';
function CreateFileStream(filename: string; openflag: byte): IFileStream; external 'enZGLine.dll';
function CreateMemoryStream: IMemoryStream; external 'enZGLine.dll';
procedure DeleteFileStream  (stream: IFileStream); external 'enZGLine.dll';
procedure DeleteMemoryStream(stream: IMemoryStream); external 'enZGLine.dll';

var
  eng: IEngine                = nil;
  log: ILog                   = nil;
  wnd: IWindow                = nil;
  fsys: IFileSystem           = nil;
  inp: IInput                 = nil;
  ogl: IOpenGL                = nil;
  tex: ITexture               = nil;
  mdl: IModel                 = nil;
  vbo: IVertexBufferObject    = nil;
  vfp: IVertexFragmentProgram = nil;
  oal: IOpenAL                = nil;
  math3D: IMath               = nil;

procedure InitENZGLINE;

implementation

procedure InitENZGLINE;
begin
  eng := enZGLineInit;
  log := eng.GetLog;
  inp := eng.GetInp;
  wnd := eng.GetWnd;
  fsys := eng.GetFSys;
  tex := eng.GetTex;
  ogl := eng.GetOGL;
  mdl := eng.GetMdl;
  vbo := eng.GetVBO;
  vfp := eng.GetVFP;
  math3D := eng.GetMath;  
  oal := eng.GetOAL;
end;

end.
